--------------------------------------------------------
-- Holy Sonar - Initialization --
--------------------------------------------------------
HolySonar = LibStub("AceAddon-3.0"):NewAddon("HolyNovaSonar", "AceConsole-3.0")
local ACD = LibStub("AceConfigDialog-3.0") -- Also for options panel

if not HolySonar then return end

local frame = HolySonar.frame
if (not frame) then
	frame = CreateFrame("Frame", "HolySonar_Frame")
	HolySonar.frame = frame
end

HolySonar.frame:SetScript("OnEvent", function(this, event, ...) return HolySonar:EventCapture(this, event, ...) end)

HolySonar.frame:RegisterEvent("PLAYER_LOGIN")
HolySonar.frame:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
HolySonar.frame:RegisterEvent("PLAYER_REGEN_ENABLED")
HolySonar.frame:RegisterEvent("PLAYER_REGEN_DISABLED")


function HolySonar:SlashProcessor_HOLYSONAR(msg) 
	local msg, v2 = msg:match("^(%S*)%s*(.-)$")
	msg = msg:lower()
	if msg == "" then
		print"|cffffd200Holy Nova|r |cff69ccf0Sonar|r:"
		print"/hns opt - Open HNS Options"
		print"/hns lock - Toggle Movability"
		print"/hns radar - Toggle Radar"
		print"/hns icon - Toggle HN icon"
		print"/hns on/off/toggle - Toggle visibility of addon"
		print"---------------------------------------"
	elseif msg == "radar" then
		if HolySonar.db.profile.radar.enable then
			HolySonar.db.profile.radar.enable = false
		else
			HolySonar.db.profile.radar.enable = true
		end
		HolySonar.Radar:ApplyOptions()
		HolySonar:optionsChanged()
	elseif msg == "icon" then
		if HolySonar.db.profile.icon.enable then
			HolySonar.db.profile.icon.enable = false
		else
			HolySonar.db.profile.icon.enable = true
		end
		HolySonar.HolyNovaIcon:ApplyOptions()
		HolySonar:optionsChanged()
	elseif msg == "off" or msg == "on" or msg == "toggle" then
		if (HolySonar.db.profile.icon.enable or msg == "off") and msg ~= "on" then
			HolySonar.db.profile.icon.enable = false
		else
			HolySonar.db.profile.icon.enable = true
		end
		if (HolySonar.db.profile.radar.enable or msg == "off") and msg ~= "on" then
			HolySonar.db.profile.radar.enable = false
		else
			HolySonar.db.profile.radar.enable = true
		end
		HolySonar.Radar:ApplyOptions()
		HolySonar.HolyNovaIcon:ApplyOptions()
		HolySonar:optionsChanged()
	elseif msg == "options" or msg == "opt" then
		ACD:Open("HolyNovaSonar")
	elseif msg == "lock" or msg == "unlock" then
		HolySonar.db.profile.lock = not HolySonar.db.profile.lock
		HolySonar:optionsChanged()
	elseif msg == "dev" then
		local x, y, _, mapId = UnitPosition("player")
		print(mapId,x,y)
	elseif msg == "pos" then
		local x1, y1 = UnitPosition("player")
		local x2, y2 = UnitPosition("party1")
		local dist = HolySonar:getDistance(x1,y1,x2,y2)
		print(x1,y1,x2,y2)
		print(dist)
	elseif msg == "healvalue" then
		print(HolySonar:getHolyNovaHealingValue())
	end
end 

--------------------------------------------------------